Subject: RE: On cross-certificates and pathLenConstraint

From: Sharon Boeyen <[email-masked]>
Date: Wed, 1 Sep 2004 10:56:09 -0400

Specifically on name constraints, I believe the reason this text please note
that the current X.509 work is adding the ability to configure those exact
variables in its path validation module. This is part of the ongoing
enhancement work that is now underway. I think (but my memory is not very
good) that the 3280 text was added around the same time we initiated the 509
work. 

While I do agree that enabling more of those path validation variables to be
configurable is a good thing, how a particular implementation actually
chooses to populate those variables needs to be left flexible. In some cases
populating them from corresponding values in a self signed cert makes sense,
but not in other cases. 

Cheers,
Sharon

-----Original Message-----
From: [email-masked] [mailto:[email-masked]] On
Behalf Of Tom Gindin
Sent: Wednesday, September 01, 2004 7:20 AM
To: Santosh Chokhani
Cc: [email-masked]
Subject: RE: On cross-certificates and pathLenConstraint

        Santosh:

        This has come up before, as I indicated in my last posting.  I ask 
for consensus to the effect that setting permitted_subtrees, 
excluded_subtrees, and max_path_length from configuration entries 
specifiable on a per-trust-anchor basis is a permissible "augmentation" of 
the RFC 3280 algorithm of the sort contemplated in the third and fourth 
sentences of RFC 3280 6.2.  In fact, the fourth sentence of that section 
explicitly suggests using name constraints in this way even though RFC 
3280 6.1.2 gives specific initial values for the "subtrees" parameters 
just as it does for max_path_length.  The initialization of 
max_path_length to "n" has no particular effect that would not be obtained 
by setting it to a large positive value instead.
        Obviously, packaging such a configuration entry within a v3 
certificate has no effect relevant to RFC 3280.  If the configuration 
entry is allowed, it may be derived from a certificate or may come from a 
file, at the RP's option.
        Although the argument above is based on the text of RFC 3280, I am 
not making it solely for that reason.  I believe that it is technically 
appropriate to implement such a feature as well.  In particular, an RP may 
have legitimate reasons to trust a departmental CA directly, and set 
max_path_length to 0; to trust a CA's EE certificates without trusting his 
cross certificates, also by setting max_path_length to 0; or to impose a 
naming space restriction on a directly trusted CA by setting 
permitted_subtrees.  I do not claim that I can compose plausible use cases 
for the entire breadth of these parameters.

                Tom Gindin

"Santosh Chokhani" <[email-masked]>
Sent by: [email-masked]
08/31/2004 12:19 PM
 
        To:     <[email-masked]>
        cc: 
        Subject:        RE: On cross-certificates and pathLenConstraint

Stefan:

I think a trust anchor is not necessarily a certificate, let alone a CA
certificate.  Thus, 4.2.1.10 does not apply.  Also, as I have noted to
Sharon, you can not enforce the cA flag or initialize path length from the
root.  Thus, the use of this extension in the root is meaningless.

As to accepting constraints from the root, those that 3280 permits to be
initialized, is fine.  Path length is not one of them.

-----Original Message-----
From: Stefan Santesson [mailto:[email-masked]] 
Sent: Tuesday, August 31, 2004 11:32 AM
To: Santosh Chokhani; [email-masked]
Subject: RE: On cross-certificates and pathLenConstraint

Santosh,

You are right that you may provide trust information by means other than a
certificate, but if you form a root certificate according to RFC 3280, 
then
basic constraints MUST be present or the certificate is NOT RFC 3280
compliant.

RFC 3280 4.2.1.10
   This extension MUST appear as a critical extension in all CA
   certificates that contain public keys used to validate digital
   signatures on certificates.

Which is perfectly true also for roots.

Secondly, section 6.1 of RFC 3280 states:
   A particular certification path may not, however, be appropriate for
   all applications.  Therefore, an application MAY augment this
   algorithm to further limit the set of valid paths.

Accepting constraints configured in the applied root as input variables 
into
the path processing is therefore completely allowed by RFC 3280 path
processing as a way to augment the mandatory algorithm to further 
constrain
trust.

Stefan Santesson
Microsoft Security Center of Excellence (SCOE)

> -----Original Message-----
> From: [email-masked] 
> [mailto:[email-masked]]
> On Behalf Of Santosh Chokhani
> Sent: den 31 augusti 2004 13:47
> To: [email-masked]
> Subject: RE: On cross-certificates and pathLenConstraint
> 
> 
> Stefan:
> 
> The standard does NOT require basic constraints to be in the root.
> 
> Also, when you enforce constraints on the trust anchor certificate, 
> that is not in compliance with the standard.
> 
> I agree that a more flexible standard would be one that honors 
> extensions in the root and also permits most of the values to be 
> initialized.  I know both X.509 and 3280 are moving towards the second 
> one.  The first one can become
> a backward compatibility issue.
> 
> -----Original Message-----
> From: [email-masked] 
> [mailto:[email-masked]]
> On
> Behalf Of Stefan Santesson
> Sent: Tuesday, August 31, 2004 6:26 AM
> To: Santoni Adriano; Peter Hesse; David P. Kemp
> Cc: [email-masked]
> Subject: RE: On cross-certificates and pathLenConstraint
> 
> 
> 
> Santoni,
> 
> I just want to add/clarify that I agree that discarding all extensions 
> of root certificates in path processing is a bad design.
> 
> The result is as you conclude that Basic Constraints MUST be present 
> in roots but any present path length constraints, policy constraints, 
> explicit policies, name constraints etc, MAY be ignored.
> 
> However, as Sharon pointed out, it is not a violation of RFC 3280 to 
> honour any constraints set in the root certificate so MS CAPIs 
> decision to enforce ROOT extensions in this manner is not in conflict 
> with RFC 3280, but you can't rely on that other RFC 3280 compliant 
> implementations will do
this.
> They may legitimately ignore this data.
> 
> 
> Stefan Santesson
> Microsoft Security Center of Excellence (SCOE)
> 
> 
> > -----Original Message-----
> > From: [email-masked] 
> > [mailto:[email-masked]]
> > On Behalf Of Santoni Adriano
> > Sent: den 31 augusti 2004 09:26
> > To: Peter Hesse; David P. Kemp
> > Cc: [email-masked]
> > Subject: R: On cross-certificates and pathLenConstraint
> >
> >
> > If I am getting you right, you are saying that the exensions in the
> > self- signed certificate of a trust anchor (root CA) should be 
> > ignored. This is quite suprising to me!
> >
> > I thought it perfectly made sense to insert in a root CA certificate 
> > a basicConstraints with cA=TRUE and pathLenConstraint=0 (for
> > example) to signify that that CA only issues certificates to
> > end-users and not to subordinates. I am talking about the 
> > self-signed certificate used by an autonomous CA to distribute its 
> > own public key in a way that allows easy import into virtually all 
> > applications. [On the other hand, what CAs distribute their own 
> > public keys as a bare public keys? Virtually none.]
> >
> > It suddenly comes to my mind that perhaps the extensions in the root 
> > CA certificates contained in the Windows store were inserted for the 
> > sole purposes of accommodating MS CAPI idiosyncrasies (like 
> > mentioned by
> > Santesson) ...
> >
> > However, RFC 3280 says (§ 4.2.1.10  Basic Constraints):
> >              "...This extension MUST appear as a critical extension 
> > in
all
> CA
> > certificates
> >              that contain public keys used to validate digital
signatures on
> > certificates" ?
> >
> > (and the same hold for other extensions as well)
> >
> > It does not say "all CA certificates that are not trust anchors"; it 
> > says "all CA certificates".
> >
> > Is this statement not conflicting with your one?
> >
> > Adriano
> >
> >
> > -----Messaggio originale-----
> > Da: [email-masked] 
> > [mailto:[email-masked]]
> > Per conto di Peter Hesse
> > Inviato: lunedì 30 agosto 2004 18.43
> > A: 'David P. Kemp'; [email-masked]
> > Oggetto: RE: On cross-certificates and pathLenConstraint
> >
> >
> >
> > Section 6.1 of RFC 3280 states:
> >
> >    When the trust anchor is provided in the form of a self-signed
> >    certificate, this self-signed certificate is not included as part
of
> >    the prospective certification path.  Information about trust
anchors
> >    are provided as inputs to the certification path validation
algorithm
> >    (section 6.1.1).
> >
> > Thus I agree with Santosh that in no case should the extensions in a 
> > trust anchor's self-signed certificate affect the certification path 
> > validation.
> >
> > --Peter
> >
> > +---------------------------------------------------------------+
> > | Peter Hesse                    [email-masked]     |
> > | Phone: (703)934-2031         Gemini Security Solutions, Inc.  |
> > | ICQ: 1942828                     www.geminisecurity.com       |
> > +---------------------------------------------------------------+
> > "Pay no attention to what the critics say; there has never been a 
> > statue set up in honor of a critic." --Jean Sibelius
> >
> >
> > > -----Original Message-----
> > > From: [email-masked] 
> > > [mailto:[email-masked]] On Behalf Of David P. Kemp
> > > Sent: Monday, August 30, 2004 11:51 AM
> > > To: [email-masked]
> > > Subject: Re: On cross-certificates and pathLenConstraint
> > >
> > >
> > > Santosh,
> > >
> > > Is there ambiguity in the term trust anchor?  It seems possible to 
> > > regard the trust anchor as a bare public key or as a certificate.
> > >
> > > Because a self-signed certificate should appear only once at the 
> > > head of a path (and never elsewhere) the rule of "no extensions in 
> > > trust anchors" should apply only if "trust anchor" is defined to 
> > > be a public key that can be used to verify a certificate 
> > > (self-signed or otherwise).  It should not apply if the 
> > > self-signed certificate itself is defined to be the trust anchor.
> > >
> > > Perhaps X.509 and RFC 3280 should be clarified to state that there 
> > > is no such thing as a "self signed root".  There are roots (trust
> > > anchors) that are public keys only, and there are self signed
> > > certificates that may be validated by a root and whose extensions 
> > > are to be honored.
> > >
> > > Dave
> > >
> > >
> > > Santosh Chokhani wrote:
> > >
> > > >Stefan:
> > > >
> > > >I think extensions should be ignored in the trust anchor
> > > regardless of
> > > >their criticality
> > > >
> > > >For reasons such as MS CAPI, it is best to keep the trust anchors 
> > > >to bear minimum required.
> > > >
> > > >-----Original Message-----
> > > >From: Stefan Santesson [mailto:[email-masked]]
> > > >Sent: Saturday, August 28, 2004 5:10 AM
> > > >To: Santosh Chokhani; [email-masked]
> > > >Subject: RE: On cross-certificates and pathLenConstraint
> > > >
> > > >
> > > >The case when CA A is a self-signed root is different.
> > > >
> > > >If the Path Length constraint is present in the self signed root, 
> > > >it will be ignored by a X.509 and RFC 3280 compliant path
> > > validation implementation.
> > > >
> > > >However, there are implementations that honour Root
> > > extensions despite
> > > >this and would thus honour Path length constraints present in 
> > > >roots. E.g. I know that MS CAPI will.
> > > >
> > > >Despite that, I would say that it is wrong to rely on critical 
> > > >extensions in root certificates since they are ignored in
> > > RFC 3280 path validation.
> > > >
> > > >Stefan Santesson
> > > >Microsoft Security Center of Excellence (SCOE)
> > > >
> > > >
> > > >
> > > >
> > > >>-----Original Message-----
> > > >>From: [email-masked] 
> > > >>[mailto:[email-masked]]
> > > >>On Behalf Of Santosh Chokhani
> > > >>Sent: den 28 augusti 2004 00:52
> > > >>To: [email-masked]
> > > >>Subject: RE: On cross-certificates and pathLenConstraint
> > > >>
> > > >>
> > > >>Stefan has the right idea.
> > > >>
> > > >>If CA A is simply another CA, CA B certificate can be
> > > validated as an
> > > >>end (not intermediate certificate).
> > > >>
> > > >>If CA A is trust anchor, I think it can issue CA
> > > certificates.  I read
> > > >>both X.509 and 3280 to not enforce constraints in the trust 
> > > >>anchor.
> > > >>
> > > >>To complicate matters further, if the trust anchor issues itself 
> > > >>a self-issued certificate, I would think the pathLength in that 
> > > >>certificate should be honored.
> > > >>
> > > >>BTW, all this discussion of hierarchies and cross
> > > certificates should
> > > >>not be relevant.  Both X.509 and 3280 are (rightfully) trust 
> > > >>model agnostic.
> > > >>
> > > >>-----Original Message-----
> > > >>From: [email-masked] 
> > > >>[mailto:[email-masked]]
> > > >>On
> > > >>Behalf Of Santoni Adriano
> > > >>Sent: Friday, August 27, 2004 9:28 AM
> > > >>To: Sharon Boeyen
> > > >>Cc: [email-masked]
> > > >>Subject: R: On cross-certificates and pathLenConstraint
> > > >>
> > > >>
> > > >>
> > > >>Sharon,
> > > >>
> > > >>you explained what happens when a cross-certificates contains a 
> > > >>pathLenConstraint=0, but I was referring to the
> > > pathLenConstraint in
> > > >>the trust-point certificate. Virtually all CA public keys are 
> > > >>distributed to end-users in the form of a self-signed 
> > > >>certificate which may (should) contain the BasicConstrains 
> > > >>extension. Some EU profiles actually mandate the BasicConstrains 
> > > >>to be present and critical.
> > > >>
> > > >>Using your example entities, my question can be re-phrased like
> > > >>follows: can CA A (my trust point) issue a cross-cert to CA
> > > B (e.g. a
> > > >>foreign one) if the self-issued certificate of CA A contains 
> > > >>pathLenConstraint=0 ?
> > > >>
> > > >>>From another viewpoint: setting pathLenConstraint=0 to prevent
> > > >>
> > > >>
> > > >>>hierarchical SubCAs does also hinder cross-certificates?
> > > >>>
> > > >>>
> > > >>Adriano
> > > >>
> > > >>-----Messaggio originale-----
> > > >>Da: Sharon Boeyen [mailto:[email-masked]]
> > > >>Inviato: venerdì 27 agosto 2004 14.34
> > > >>A: Santoni Adriano; [email-masked]
> > > >>Oggetto: RE: On cross-certificates and pathLenConstraint
> > > >>
> > > >>
> > > >>If you are talking about a non-hierarchical trust model, then 
> > > >>absolutely yes any CA can issue any cross-certificates they 
> > > >>wish. However, those cross-certificates will only be trusted if 
> > > >>paths are built to them that exclude the certificate that 
> > > >>contains the path length constraint.
> > > >>
> > > >>For example, take CA A, CA B, CA C and CA D
> > > >>
> > > >>CA A issues a cross certificate to CA B with a path length
> > > constraint
> > > >>of 0 CA B issues a cross certificate to CA C CA D issues a cross 
> > > >>certificate to CA B (no path length constraint)
> > > >>
> > > >>Assume that there are no other cross certs in the environment
> > > >>
> > > >>Users of CA A have no way to trust certificates issued by CA C 
> > > >>(because of the path length constraint)
> > > >>
> > > >>However, users of CA D are able to trust certificates
> > > issued by CA C
> > > >>because the cross-certificate from D to B contains no such
> > > constraint.
> > > >>
> > > >>As for your second question, yes there are implementations that 
> > > >>process paths including all the business controls. As for
> > > testing, I'd
> > > >>suggest you have a look at the PKITS test suite which tests
> > > all these
> > > >>features. http://csrc.nist.gov/pki/testing/x509paths.html
> > > >>
> > > >>Cheers,
> > > >>Sharon
> > > >>
> > > >>-----Original Message-----
> > > >>From: [email-masked] 
> > > >>[mailto:[email-masked]]
> > > >>On
> > > >>Behalf Of Santoni Adriano
> > > >>Sent: Friday, August 27, 2004 5:37 AM
> > > >>To: [email-masked]
> > > >>Subject: On cross-certificates and pathLenConstraint
> > > >>
> > > >>
> > > >>
> > > >>Dear list,
> > > >>
> > > >>I have the following doubts regarding cross-certificates:
> > > >>
> > > >>can a CA with BasicConstraints.pathLenConstraint=0 issue a
> > > >>cross- certificate to another CA in a different domain?
> > > >>
> > > >>In case of a "cross-certificate" (so to speak) issued by
> > > the same CA
> > > >>for itself, to facilitate the CA key rollover, RFC 3280 seems to 
> > > >>to allow the cross-certificate issuance regardless of the 
> > > >>pathLenConstraint value, on the ground that in this case the 
> > > >>cross-certificate is "self-issued" and therefore, in a way, "out 
> > > >>of scope" as far as the pathLenConstraint is concerned.
> > > >>
> > > >>However, in the case of a "real" cross-certificate, to be issued 
> > > >>to another CA with a different name, it is not very clear to me 
> > > >>if the pathLenConstraint in CA1 affects the possibility of 
> > > >>issuing a cross-certificate to CA2.
> > > >>
> > > >>By the way, I wonder how are the most widespread
> > > applications handling
> > > >>certificate chains containing cross-certs, in the various
> > > cases (e.g.
> > > >>different values of pethLenConstraint down the chain); has 
> > > >>anybody done any testing to specifically investigate this area?
> > > >>
> > > >>Is anybody willing to shed some light and/or share informations?
> > > >>
> > > >>TIA,
> > > >>  Adriano
> > > >>
> > > >>
> > > >>*******************Internet Email Confidentiality
> > > >>Footer*******************
> > > >>
> > > >>
> > > >>Qualsiasi utilizzo non autorizzato del presente messaggio
> > > nonche dei
> > > >>suoi allegati e vietato e potrebbe costituire reato. Se ha 
> > > >>ricevuto per errore il presente messaggio, Le saremmo grati se 
> > > >>ci
> > > inviasse, via
> > > >>e-mail, una comunicazione al riguardo e provvedesse nel
> > > contempo alla
> > > >>distruzione del messaggio stesso e dei suoi eventuali allegati. 
> > > >>Le dichiarazioni contenute nel presente messaggio nonche' nei 
> > > >>suoi eventuali allegati devono essere attribuite esclusivamente
> > > al mittente
> > > >>e non possono essere considerate come trasmesse o autorizzate da 
> > > >>ACTALIS S.p.A.; le medesime dichiarazioni non impegnano
> > > ACTALIS S.p.A.
> > > >>nei confronti del destinatario o di terzi.
> > > >>ACTALIS S.p.A. non si assume alcuna responsabilita' per 
> > > >>eventuali intercettazioni, modifiche o danneggiamenti del 
> > > >>presente
> > > messaggio e-mail.
> > > >>
> > > >>
> > > >>
> > > >>Any unauthorized use of this e-mail or any of its attachments is 
> > > >>prohibited and could constitute an offence. If you are not the 
> > > >>intended addressee please advise immediately the sender by
> > > using the
> > > >>reply facility in your e-mail software and destroy the
> > > message and its
> > > >>attachments. The statements and opinions expressed in this 
> > > >>e-mail message are those of the author of the message and do not
> > > necessarily
> > > >>represent those of ACTALIS S.p.A. Besides, The contents of this 
> > > >>message shall be understood as neither given nor endorsed
> > > by ACTALIS
> > > >>S.p.A..
> > > >>ACTALIS S.p.A. does not accept liability for corruption,
> > > interception
> > > >>or amendment, if any, or the consequences thereof.
> > > >>
> > > >>
> > > >>*******************Internet Email Confidentiality
> > > >>Footer*******************
> > > >>
> > > >>
> > > >>Qualsiasi utilizzo non autorizzato del presente messaggio
> > > nonché dei
> > > >>suoi allegati è vietato e potrebbe costituire reato. Se ha 
> > > >>ricevuto per errore il presente messaggio, Le saremmo grati se 
> > > >>ci
> > > inviasse, via
> > > >>e-mail, una comunicazione al riguardo e provvedesse nel
> > > contempo alla
> > > >>distruzione del messaggio stesso e dei suoi eventuali allegati. 
> > > >>Le dichiarazioni contenute nel presente messaggio nonche' nei 
> > > >>suoi eventuali allegati devono essere attribuite esclusivamente
> > > al mittente
> > > >>e non possono essere considerate come trasmesse o autorizzate da 
> > > >>ACTALIS S.p.A.; le medesime dichiarazioni non impegnano
> > > ACTALIS S.p.A.
> > > >>nei confronti del destinatario o di terzi.
> > > >>ACTALIS S.p.A. non si assume alcuna responsabilita' per 
> > > >>eventuali intercettazioni, modifiche o danneggiamenti del 
> > > >>presente
> > > messaggio e-mail.
> > > >>
> > > >>
> > > >>
> > > >>Any unauthorized use of this e-mail or any of its attachments is 
> > > >>prohibited and could constitute an offence. If you are not the 
> > > >>intended addressee please advise immediately the sender by
> > > using the
> > > >>reply facility in your e-mail software and destroy the
> > > message and its
> > > >>attachments. The statements and opinions expressed in this 
> > > >>e-mail message are those of the author of the message and do not
> > > necessarily
> > > >>represent those of ACTALIS S.p.A. Besides, The contents of this 
> > > >>message shall be understood as neither given nor endorsed
> > > by ACTALIS
> > > >>S.p.A..
> > > >>ACTALIS S.p.A. does not accept liability for corruption,
> > > interception
> > > >>or amendment, if any, or the consequences thereof.
> > > >>
> > > >>
> > > >>
> > > >>
> > > >>
> > > >
> > > >
> > > >
> > > >
> > > >
> > > >
> > >
> >
> >
> > *******************Internet Email Confidentiality
> > Footer*******************
> >
> >
> > Qualsiasi utilizzo non autorizzato del presente messaggio nonché dei 
> > suoi allegati è vietato e potrebbe costituire reato. Se ha ricevuto 
> > per errore il presente messaggio, Le saremmo grati se ci inviasse, 
> > via e-mail, una comunicazione al riguardo e provvedesse nel contempo 
> > alla distruzione del messaggio stesso e dei suoi eventuali allegati. 
> > Le dichiarazioni contenute nel presente messaggio nonche' nei suoi 
> > eventuali allegati devono essere attribuite esclusivamente al 
> > mittente e non possono essere considerate come trasmesse o 
> > autorizzate da ACTALIS S.p.A.; le medesime dichiarazioni non 
> > impegnano ACTALIS S.p.A. nei confronti del destinatario o di terzi. 
> > ACTALIS S.p.A. non si assume alcuna responsabilita' per eventuali 
> > intercettazioni, modifiche o danneggiamenti del presente messaggio 
> > e-mail.
> >
> >
> >
> > Any unauthorized use of this e-mail or any of its attachments is 
> > prohibited and could constitute an offence. If you are not the 
> > intended addressee please advise immediately the sender by using the 
> > reply facility in your e-mail software and destroy the message and 
> > its attachments. The statements and opinions expressed in this 
> > e-mail message are those of the author of the message and do not 
> > necessarily represent those of ACTALIS S.p.A. Besides, The contents 
> > of this message shall be understood as neither given nor endorsed by 
> > ACTALIS S.p.A.. ACTALIS S.p.A. does not accept liability for 
> > corruption, interception or amendment, if any, or the consequences 
> > thereof.
> >
> >
> 
>

---

From: "Stefan Santesson" <[email-masked]>
Date: Thu, 2 Sep 2004 11:03:51 +0100

Agreed, except the fact that NIST PKITS tests doesn't have any test
cases that detects this since it doesn't provide any Root certificates
with constraints :(

/Stefan

> Sent: den 2 september 2004 04:48
> To: [email-masked]
> I am ok with it as long as long as if a product or toolkit or API that
> claims 3280 compliance, provides an interface to the path validation
> engine
> to test compliance with 3280 and it passes the NIST PKITS tests.
> 
> Sent: Wednesday, September 01, 2004 8:40 PM
> To: Peter Hesse; Santosh Chokhani; Steve Hanna
> Cc: [email-masked]
> Applying local trust policies is not a matter of interoperability. It
is
> just a matter of local policy.
> 
> An application may be configured, in accordance with local policy to
> reject
> a certificate based on any reason it chooses.
> 
> We are not arguing about how RFC 3280 path validation works. RFC 3280
path
> validation ignores TA extensions. Period.
> 
> But if an application chooses to accept any restrictions set in the TA
> certificate, it is entitled to do so at its own discretion. It is not
up
> to
> any standard to say that it can't. This is then of course no longer
basic
> RFC 3280 validation, but some form of augmented RFC 3280 path
validation
> (I.e RFC 3280 path validation + some locally defined additional
> constraints).
> 
> The only interoperability issue at hand is to make sure that all
> applications 1) who choose just basic RFC 3280 path validation use the
> same
> rules and optionally 2) that those who choose to honour TA extensions
may
> do
> so in a uniform manner thanks to clearly defined rules.
> 
> Note this mail is not a proposal to start working on 2).
> 
> /Stefan
> 
> 
> > On Behalf Of Peter Hesse
> > Sent: den 1 september 2004 21:06
> > To: 'Santosh Chokhani'; Stefan Santesson; 'Steve Hanna'
> > Cc: [email-masked]
> > I agree wholeheartedly with Santosh.  Interoperability is what will
be
> > adversely affected if people use trust anchors to initialize path
> > processing in different ways.  We should have a standard which
clearly
> > defines
> how
> > this
> > mechanism should take place.
> >
> > IMHO, CA vendors should be able to produce a self-signed certificate
> with
> > no
> > (or few) extensions for basic interoperability, and one or more
> additional
> > self-signed certificates containing initialization parameters for
> > applications which can make use of them.  Likewise with certificate
> > validation systems--they should be able to import a self-signed
> > certificate as just a trust root (name and public key only) as well
as
> > an path validation initialization object (looking at things like
> > initial name constraints).
> >
> > --Peter
> >
> > > [mailto:[email-masked]] On Behalf Of Santosh
Chokhani
> > > Sent: Wednesday, September 01, 2004 2:16 PM
> > > To: 'Stefan Santesson'; 'Steve Hanna'
> > > Cc: [email-masked]
> > > Stefan and Steve Hanna:
> > > Section 6.1 also states the following:
> > >
> > > "This section describes an algorithm for validating certification
> > >    paths.  Conforming implementations of this specification are
not
> > >    required to implement this algorithm, but MUST provide
> > > functionality
> > >    equivalent to the external behavior resulting from this
> procedure.
> > >    Any algorithm may be used by a particular implementation so
long
> as
> > >    it derives the correct result."
> > >
> > > While I agree that we could take the values from trust anchor to
> > > initialize the certification path validation, that is not what the
> > > standard permits.
> > >
> > > As to your statement on Section 6.2, the language you cite and the
> > > examples imply items that either not integral to certification
path
> > > validation or are to process application specific extensions.  The
> > > name constraints example is states "apply name constraints to a
> > > specific trust anchor during
> > >    the initialization phase".  This can mean is the trust anchor
> > > appropriate for the name space.  Similarly, the subject alt name
in
> > > the end certificate is a pre or post path validation example.
> > >
> > > I am also concerned about your interpretation since it has
negative
> > > implications for interoperability.
> > >
> > > Having said that, I am not averse to a change in the standard that
> > > clearly defines what values can be initialized.
> > >
> > > [mailto:[email-masked]] On Behalf Of Stefan
Santesson
> > > Sent: Tuesday, August 31, 2004 7:52 PM
> > > To: Steve Hanna; Santosh Chokhani
> > > Cc: [email-masked]
> > > Subject: RE: R: On cross-certificates and pathLenConstraint
> > >
> > >
> > >
> > > Thanks Steve for jumping in on this.
> > >
> > > We completely agree on the facts of RFC 3280 path processing and I
> > > think you showed this very well with support from the standard
text.
> > >
> > > We happen to disagree on the good or bad with processing root
> > > extensions but I think we should save that to later :-)
> > >
> > > Stefan Santesson
> > > > On Behalf Of Steve Hanna
> > > > Sent: den 31 augusti 2004 22:05
> > > > To: Santosh Chokhani
> > > > Cc: [email-masked]
> > > > Subject: Re: R: On cross-certificates and pathLenConstraint
> > > >
> > > >
> > > > RFC 3280 says in section 6.1:
> > > >
> > > >     A particular certification path may not, however, be
> appropriate
> > > for
> > > > and in section 6.2:
> > > >     An implementation that supports multiple trust anchors
> > > >     MAY augment the algorithm presented in section 6.1 to
further
> > > limit
> > > >     the set of valid certification paths which begin with a
> > > particular
> > > >     trust anchor.  For example, an implementation MAY modify the
> > > >     algorithm to apply name constraints to a specific trust
anchor
> > > during
> > > >     the initialization phase, or the application MAY require the
> > > presence
> > > >     of a particular alternative name form in the end entity
> > > certificate,
> > > >     or the application MAY impose requirements on
> > > application-specific
> > > >     extensions.  Thus, the path validation algorithm presented
in
> > > section
> > > >     6.1 defines the minimum conditions for a path to be
considered
> > > valid.
> > > >
> > > > Therefore, I believe that path validation implementations can go
> > > > beyond the usual path validation algorithm to impose any
> additional
> > > > requirements on paths that it likes (unless specifically
> > > prohibited by
> > > > RFC 3280). This would include processing name constraints in
trust
> > > > anchors, pathLenConstraints in trust anchors, etc.
> > > >
> > > > However, CAs who expect to act as trust anchors and issue
> > > self-signed
> > > > certificates for that purpose should not assume that all path
> > > > validation implementations will do this. If they REALLY
> > > want to ensure
> > > > that path lengths are limited, they should certify a
> > > subsidiary CA and
> > > > include a pathLen constraint in that certificate.
> > > >
> > > > Now, there's a separate question about whether processing
> > > constraints
> > > > in trust anchors is a good idea. I would argue that it's not.
But
> > > > that's a topic for another email.
> > > >
> > > > Thanks,
> > > >
> > > > Steve
> > > >
> > > > Santosh Chokhani wrote:
> > > >
> > > > > Steve Kent:
> > > > >
> > > > > We could take extensions in the TA and use them to initialize
a
> > > > > certification path values permitted by 3280, but for
> > > values such as
> > > path
> > > > > length that 3280 does not permit initialization of to an
> arbitrary
> > > > value, it
> > > > > will require a change in the standard.
> > > > >
> > > > > From security viewpoint, I do not object to it, but it is a
> change
> > > to
> > > > the
> > > > > standard.
> > > > >
> > > > > Behalf Of Stephen Kent
> > > > > Sent: Tuesday, August 31, 2004 9:51 AM
> > > > > To: Santoni Adriano
> > > > > Cc: [email-masked]
> > > > > Subject: Re: R: On cross-certificates and pathLenConstraint
> > > > >
> > > > >
> > > > >
> > > > > At 9:25 AM +0200 8/31/04, Santoni Adriano wrote:
> > > > >
> > > > >>self-signed certificate of a trust anchor (root CA) should be
> > > > > Unfortunately that is what X.509 has said for some time, and
> 3280
> > > has
> > > > > not deviated in this regard. I too was surprised by this
> > > initially.
> > > > >
> > > > > I discussed this issue with Sharon some time ago, noting
> > > that, for
> > > > > example, one would like to impose name constraints through
> > > > > configuration of trust anchors and the TA exception to
> > > the general
> > > > > processing rules prohibits that.  So I agree completely
> > > that I would
> > > > > like to see at least SOME of the constraints in a trust
> > > anchor cert
> > > > > be applied to cert path processing, although one needs to
> > > carefully
> > > > > examine the implications of doing this.
> > > > >
> > > > > BTW, Santosh is correct in noting that TAs are not
> > > literally certs,
> > > > > even though self-signed certs are often used as a means of
> > > > > representing TAs. However, since we admit that a TA can
contain
> > > > > parameters other than the TA name and key info, I think it is
> > > > > reasonable to allow for the full range of extensions that
might
> > > > > appear in a CA cert, and to then use them (most of them?)
> > > to control
> > > > > path processing.
> > > > >
> > > > > Steve
> > > > >
> > >
> > >
> 
>

---

From: "Stefan Santesson" <[email-masked]>
Date: Thu, 2 Sep 2004 21:55:10 +0100

Steve,

I've learned that in discussions like this you have to make small steps
and agree on the fundamental basics before you can dig into details.

So I just try to establish the simple truth that RP's have the right to
deny trust in any certificate for any reason. And I mean literally ANY
reason. No exception what so ever.

The right to augment path validation for this purpose is also clearly
supported by RFC 3280. No limitation to this right is indicated or
suggested.

I have not gone into the technical details yet but I can say so much
that I can see many ways to do obtain this RESULT without "injecting"
variables into the RFC 3280 path validation algorithm. Especially since
this algorithm anyway only serves as an example algorithm (any other
algorithm is equally allowed as long as it produces the same result).

If we can agree on this basic fundamental, then I'm more than willing to
take this to the next level and discuss different ways to realize this
technically and in what ways augmentation options can be controlled and
managed and finally the most important aspect, what support we need from
standards.

Can we agree on these basics?

/Stefan

> From: Stephen Kent [mailto:[email-masked]]
> Sent: den 2 september 2004 22:18
> To: Stefan Santesson
> Cc: Peter Hesse; Santosh Chokhani; Steve Hanna; [email-masked]
> At 1:39 AM +0100 9/2/04, Stefan Santesson wrote:
is
> >reject a certificate based on any reason it chooses.
> >
> >path validation ignores TA extensions. Period.
> >
> >certificate, it is entitled to do so at its own discretion.
> 
> I was in agreement up to this point. The path validation process
> divides has fixed aspects, and a user-settable aspects. In terms of
> initialization, the standards (X.509 and RFC 3280) don't provide a
> means to initialize some of the variables that we would like, e.g.,
> name constraints. So, I think that an application is over stepping
> the bounds of the standard if it initializes variables for which the
> standards make no such provision.
> 
> 
> >It is not up
> >to any standard to say that it can't. This is then of course no
longer
> >basic RFC 3280 validation, but some form of augmented RFC 3280 path
> >validation (I.e RFC 3280 path validation + some locally defined
> >additional constraints).
> 
> i.e., it's non-standard :-)
> 
> >same rules and optionally 2) that those who choose to honour TA
> >extensions may do so in a uniform manner thanks to clearly defined
> >rules.
> 
> well, I'm generally opposed to having a CA issue a self-signed cert
> that is used as a TA, given that the TA parameters should be
> controlled by an RP, not the CA. BUT, the reality is that many folks
> DO take such certs and use them as TAs, then the problem with your
> suggestion is that the same cert use as a TA by different RPs will
> have different effects, which is not what the CA would anticipate
> under the standard path validation algorithm. So, if what you said
> was that the USER could augment the path validation algorithm by
> initializing parameter values that the standards don't allow, I'd be
> sympathetic since the intent is to allow the user, as an RP, to do
> what he should be able to do. But, you refer to an application doing
> this, not a user, and for that I am less sympathetic, because it
> sounds like a vendor of an application making a decision for
> everyone, and that is not in the spirit of allowing the RPs to
> exercise control over the validation process.
> 
> So, which do you mean?
> 
> Steve

---

From: "Stefan Santesson" <[email-masked]>
Date: Fri, 3 Sep 2004 15:28:34 +0100

Santosh.

Short in-line

> Sent: den 3 september 2004 14:50
> To: [email-masked]
> I would note two things.  They seem to be repeat of the themes from me
in
> this thread.
> 
> 1.  For interoperability reasons, it is not sufficient to reject paths
> considered bad by 3280.  Paths considered good by 3280 should also be
> accepted.
> 
[Stefan] Agreed. I never meant to say anything else.

> 2.  The key is the RP user to be able to set the path validation
engine
> initialization variables as opposed to the engine/API making that
> determination for the entire consumer/RP community.

[Stefan] Agreed. I never meant to say anything else. However the
decision may not be taken by the user, it could be taken by his
application, his manager, his It department or whatever.

> Sent: Friday, September 03, 2004 4:05 AM
> That is not at all what I try to say.
> 
> First of all. If you have the ability to augment the standard
algorithm,
> does not mean that you necessarily don't have a default mode that you
can
> use for standard compliance testing.
> 
> Secondly, even if you run in some augmented mode, you can still make
tests
> to make sure that a bad path, actually is rejected (i.e. no valid
> augmentation allows a bad path to pass). Even in this mode you can
make
> many
> valid standards compliance claims.
> 
> Finally you are right about the tricky part to test compliance and
interop
> regarding variable initialization. This is because the algorithm
specified
> in RFC 3280 is one example of a compliant algorithm, and even if it
were
> THE
> algorithm, different implementations of it would still have different
APIs
> with different ways and methods to handle these variables.
> 
> Example.
> Implementation 1 has a certain way to initialize a variable in the API
> request and delivers a distinct result.
> 
> Implementation 2 does not provide any possibility to initialize this
> variable but does instead deliver a response that can be masked for
the
> proper mode of operation (=different variable settings).
> 
> As long as we don't standardize the APIs we will have hard time making
> these
> tests effectively.
> 
> I agree that it is a bit confusing that RFC 3280 define the ability to
> initialize some variables while it at the same time has a language
that
> opens for adding any other type of constraints to the process.
> 
> So I do believe that the only thing you can successfully test widely
is
> the
> default algorithm with default parameter settings, which is exactly
what
> NIST PKITS is doing.
> > Sent: den 3 september 2004 01:14
> > To: [email-masked]
> > An advantage of what Steve Kent is saying is that the validation
> engine's
> > compliance to 3280 can be conformance tested for the current
standard
> as
> > well as for revised standard that contained features for the RP to
> > initialize the various state variables.
> >
> > If you use your argument, we can not make any standard compliance
> claims.
> >
> > Sent: Thursday, September 02, 2004 4:18 PM
> > To: Stefan Santesson
> > >is just a matter of local policy.
> > >
the
> > bounds of the standard if it initializes variables for which the
was
> > that the USER could augment the path validation algorithm by
everyone,
> > and that is not in the spirit of allowing the RPs to exercise
control
> > over the validation process.
> >
> > So, which do you mean?
> >
> > Steve
> 
>

---

From: "Stefan Santesson" <[email-masked]>
Date: Fri, 3 Sep 2004 15:28:34 +0100

Santosh.

Short in-line

in

engine

algorithm,
can
tests
make
interop
specified
were
APIs
the
that
is
what
standard
the
was
everyone,
control

---

From: Stephen Kent <[email-masked]>
Date: Tue, 7 Sep 2004 10:33:08 -0400

>application, his manager, his It department or whatever.

It's your mention of "his application" that causes concern.  The user 
as RP should be able to make these decisions, or his management may 
do so based on corporate policy.  But if an application embodies 
these extra-standard decisions, and the app is not 
enterprise-specific, then we have a problem because the application 
vendor is not the RP and is no longer representing the wishes of the 
RP.

Steve

---

From: "Stefan Santesson" <[email-masked]>
Date: Tue, 7 Sep 2004 22:23:55 +0100

Steve,

You dress it so nicely :-)

I was not trying to make the point the way you fear. I just wanted to
point out that a certain application may be configured to implement a
certain policy and that configuration may be imposed by management. Not
necessarily by the vendor.

OK?

Now, the essence of this discussion is what it takes to claim
compliance. I'm not making any claims about any future behaviour of any
product delivered by the company I work for :-)

/Stefan

> On Behalf Of Stephen Kent
> Sent: den 7 september 2004 16:33
> To: Stefan Santesson
> Cc: Santosh Chokhani; [email-masked]

---

From: Stephen Kent <[email-masked]>
Date: Wed, 8 Sep 2004 16:46:12 -0400

>necessarily by the vendor.

In that light, yes, OK.

>product delivered by the company I work for :-)

I think it fair to say that if a product's default configuration 
passes the standards interoperability tests, it is compliant.

Steve

---

From: "Stefan Santesson" <[email-masked]>
Date: Thu, 9 Sep 2004 16:38:33 +0100

No I'm not saying that.
MS CAPI will process the root extensions and you can't turn that off.

/Stefan
 
> Sent: den 9 september 2004 13:50
> To: [email-masked]
> Are you saying that if we had constraints in a trust anchor MS CAPI
can be
> configured or invoked to ignore those?
> 
> Sent: Thursday, September 09, 2004 3:22 AM
> To: Stephen Kent
> [Stefan] I have no problem with that.
> Unfortunately however, which I pointed out to Santosh before, the NIST
PKI
> test suite doesn't provide any compliance test regarding root
extension
> processing since it doesn't make use of any root certificates with
> constraints or policies.
> 
> 
> 
>

---

From: "Stefan Santesson" <[email-masked]>
Date: Thu, 9 Sep 2004 18:17:32 +0100

Yes, 
That is what I'm saying.
The NIST test doesn't catch that though.

You can say that MSCAPI is almost faithful to RFC 3280 (with all the
best intentions) but there are other minor deviations as well that we
have on our list.

/Stefan

> Sent: den 9 september 2004 18:45
> To: Stefan Santesson
> Cc: [email-masked]
> At 4:38 PM +0100 9/9/04, Stefan Santesson wrote:
> >No I'm not saying that.
> Stefan,
> So, are you saying that MSCAPI pays attention to all extensions in a
> TA cert is when performing path validation?  if so, then it is
> non-compliant with the current X.509 and RFC 3280 (and RFC 2459)
> specs, because those specs say to NOT pay attention to name
> constraints in a TA.  Personally I would rather have cert processing
> pay attention to these extensions, but all of these specs say the
> opposite (in terms of this extension) and that has been true for some
> time.
> 
> Steve